/*-
 * ~~~~~~licensing~~~~~~
 * adapters-core
 * ==========
 * Copyright (C) 2020 - 2023 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.esb.platform.runtime.base.connecting.adapter.core.metadata;

import java.util.HashMap;
import java.util.Map;

import com.google.gson.JsonObject;

import ru.entaxy.platform.base.support.JSONUtils;

public class AdapterGeneratorElement {
    protected String type;
    
    // Default generator is defined in GeneratorFactory
    // no need to redefine it here
    protected String generator = "";

    protected JsonObject config;
    protected Map<String, Object> configMap = new HashMap<>();
    
    // we can postpone generator linking until it's really needed
    protected boolean lazy = false;
    
    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getGenerator() {
        return generator;
    }

    public void setGenerator(String generator) {
        this.generator = generator;
    }

    public Map<String, Object> getConfigMap() {
    	if (configMap.isEmpty() && (this.config != null))
    		configMap = JSONUtils.element2map(this.config);
		return configMap;
	}

	public void setConfigMap(Map<String, Object> configMap) {
		this.configMap = configMap;
	}

	// actually the method is not called by Gson
	public void setConfig(JsonObject configElement) {
		this.config = configElement; 
		this.configMap = JSONUtils.element2map(configElement);
	}

	public boolean isLazy() {
		return lazy;
	}

	public void setLazy(boolean lazy) {
		this.lazy = lazy;
	}

	public String toString() {
        return "AdapterGeneratorElement: " +
                "{'type': '" + type + "', " +
                "'generator': '" + generator + "'}";
    }
}
